**free

// parseur JSON générique

ctl-opt actgrp(*new) option(*srcstmt) bnddir('YAJL/YAJL') ;
/include yajl_h

dcl-pi *n ;
  stmf char(32) const ;
end-pi;

// Document
dcl-s docNode like(yajl_val) ;
// Erreur
dcl-s errMsg varchar(500) inz ;
// Affichage
dcl-s msg char(52) inz ;
// Niveau
dcl-s lvl uns(5) inz(0) ;



// Chargement de l'arbre JSON
docNode = yajl_stmf_load_tree( %trim( stmf ) : errMsg );
if errMsg <> '';
  msg = errMsg ;
  dsply msg ;
endif;

// Parcours du flux
parseObject( docNode : '' ) ;

// Libération des ressources
yajl_tree_free(docNode);

return ;



// Afficher une valeur
dcl-proc affiche ;
  dcl-pi *n ;
    cle varchar(50) const ;
    lvl uns(5) const ;
    valeur varchar(65535) const ;
  end-pi;

  dcl-s msg char(52) ;
  dcl-c NIVEAU '...............' ;

  msg = %subst(NIVEAU:1:lvl) + ' ' + cle ;
  dsply msg ;
  if valeur <> *blank ;
    msg = valeur ;
    dsply msg ;
  endif ;

end-proc;



// Extraire un String
dcl-proc parseString ;
  dcl-pi *n ;
    node like(yajl_val) const ;
    cle varchar(50) const ;
  end-pi;

  affiche( cle + ' (string)': lvl : yajl_get_string( node ) ) ;
end-proc;



// Extraire un Number
dcl-proc parseNumber ;
  dcl-pi *n ;
    node like(yajl_val) const ;
    cle varchar(50) const ;
  end-pi;

  affiche( cle + ' (number)' : lvl : %char( yajl_get_number( node ) ) ) ;
end-proc;



// Extraire un booléen true
dcl-proc parseTrue ;
  dcl-pi *n ;
    node like(yajl_val) const ;
    cle varchar(50) const ;
  end-pi;

  affiche( cle + ' (bool)' : lvl : 'true' ) ;
end-proc;



// Extraire un booléen false
dcl-proc parseFalse ;
  dcl-pi *n ;
    node like(yajl_val) const ;
    cle varchar(50) const ;
  end-pi;

  affiche( cle + ' (bool)' : lvl : 'false' ) ;
end-proc;



// Extraire un Null
dcl-proc parseNull ;
  dcl-pi *n ;
    node like(yajl_val) const ;
    cle varchar(50) const ;
  end-pi;

  affiche( cle + ' (null)' : lvl : 'null' ) ;
end-proc;



// Extraire un Array
dcl-proc parseArray ;
  dcl-pi *n ;
    node like(yajl_val) const ;
    cle varchar(50) const ;
  end-pi;

  dcl-s curNode like(yajl_val) inz ;
  dcl-s idx int(10) inz ;

  lvl += 1 ;
  affiche( cle + ' (array)' : lvl : '' ) ;

  // Parcours du tableau
  dow yajl_array_loop( node : idx : curNode ) ;
    select ;
    when yajl_is_string( curNode ) ;
      parseString( curNode : '' ) ;
    when yajl_is_number( curNode ) ;
      parseNumber( curNode : '' ) ;
    when yajl_is_object( curNode ) ;
      parseObject( curNode : '' ) ;
    when yajl_is_array( curNode ) ;
      parseArray( curNode : '' ) ;
    when yajl_is_true( curNode ) ;
      parseTrue( curNode : '') ;
    when yajl_is_false( curNode ) ;
      parseFalse( curNode : '' ) ;
    when yajl_is_null( curNode ) ;
      parseNull( curNode : '' ) ;
    endsl ;
  enddo ;

  lvl -= 1 ;
end-proc;



// Extraire un Object
dcl-proc parseObject ;
  dcl-pi *n ;
    node like(yajl_val) const ;
    cle varchar(50) const ;
  end-pi;

  dcl-s curNode like(yajl_val) ;
  dcl-s curCle varchar(50) ;
  dcl-s idx int(10) inz ;

  lvl += 1 ;
  affiche( cle + ' (object)' : lvl : '' ) ;

  // Parcours des éléments de l'objet
  dow yajl_object_loop( node : idx : curCle : curNode ) ;

    select ;
    when yajl_is_string( curNode ) ;
      parseString( curNode : curCle ) ;
    when yajl_is_number( curNode ) ;
      parseNumber( curNode : curCle ) ;
    when yajl_is_object( curNode ) ;
      parseObject( curNode : curCle ) ;
    when yajl_is_array( curNode ) ;
      parseArray( curNode : curCle ) ;
    when yajl_is_true( curNode ) ;
      parseTrue( curNode : curCle ) ;
    when yajl_is_false( curNode ) ;
      parseFalse( curNode : curCle ) ;
    when yajl_is_null( curNode ) ;
      parseNull( curNode : curCle ) ;
    endsl ;

  enddo;

  lvl -= 1 ;
end-proc;